package com.dh.flutterkakaolink;

import android.content.Context;

import com.kakao.kakaolink.v2.KakaoLinkResponse;
import com.kakao.kakaolink.v2.KakaoLinkService;
import com.kakao.message.template.LinkObject;
import com.kakao.message.template.TextTemplate;
import com.kakao.network.ErrorResult;
import com.kakao.network.callback.ResponseCallback;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** FlutterKakaolinkPlugin */
public class FlutterKakaolinkPlugin implements MethodCallHandler {
    Context mcontext;

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final FlutterKakaolinkPlugin plugin = new FlutterKakaolinkPlugin(registrar);
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "flutter_kakaolink");
    channel.setMethodCallHandler(plugin);
  }

    private FlutterKakaolinkPlugin(Registrar registrar) {
        mcontext = registrar.context();
    }

    TextTemplate params = TextTemplate.newBuilder("Text", LinkObject.newBuilder().
            setWebUrl("https://developers.kakao.com").
            setMobileWebUrl("https://developers.kakao.com").
            build()).setButtonTitle("This is button").build();



  @Override
  public void onMethodCall(MethodCall call, final Result result) {
    if (call.method.equals("reqkakalink")) {
        Map<String, String> serverCallbackArgs = new HashMap<String, String>();
        serverCallbackArgs.put("user_id", "${current_user_id}");
        serverCallbackArgs.put("product_id", "${shared_product_id}");

        KakaoLinkService.getInstance().sendDefault(mcontext, params, serverCallbackArgs, new ResponseCallback<KakaoLinkResponse>() {
            @Override
            public void onFailure(ErrorResult errorResult) {
                result.success(null);
            }

            @Override
            public void onSuccess(KakaoLinkResponse successResult) {
                result.success(null);
            }
        });
    } else {
      result.notImplemented();
    }
  }
}
